searchNodes=[{"doc":"Provides a set of helpers to work with Changesets.","ref":"ChangesetHelpers.html","title":"ChangesetHelpers","type":"module"},{"doc":"Adds an error to the nested changeset. account_changeset = ChangesetHelpers . add_error ( account_changeset , [ :user , :articles , :error_key ] , &quot;Some error&quot; )","ref":"ChangesetHelpers.html#add_error/4","title":"ChangesetHelpers.add_error/4","type":"function"},{"doc":"","ref":"ChangesetHelpers.html#change_assoc/2","title":"ChangesetHelpers.change_assoc/2","type":"function"},{"doc":"Returns the nested association in a changeset. This function will first look into the changes and then fails back on data wrapped in a changeset. Changes may be added to the given changeset through the third argument. A tuple is returned containing the root changeset, and the changeset of the association. { account_changeset , address_changeset } = change_assoc ( account_changeset , [ :user , :config , :address ] , %{ street : &quot;Foo street&quot; } )","ref":"ChangesetHelpers.html#change_assoc/3","title":"ChangesetHelpers.change_assoc/3","type":"function"},{"doc":"Returns the nested association in a changeset at the given index. A tuple is returned containing the root changeset, the changesets of the association and the changeset at the specified index. See change_assoc(struct_or_changeset, keys, changes) .","ref":"ChangesetHelpers.html#change_assoc/4","title":"ChangesetHelpers.change_assoc/4","type":"function"},{"doc":"This function allows checking if a given field is different between two changesets. { street_changed , street1 , street2 } = diff_field ( account_changeset , new_account_changeset , [ :user , :config , :address , :street ] )","ref":"ChangesetHelpers.html#diff_field/3","title":"ChangesetHelpers.diff_field/3","type":"function"},{"doc":"Fetches a nested change from the given changeset. This function only looks at the :changes field of the given changeset and returns {:ok, value} if the change is present or :error if it's not. { :ok , street } = ChangesetHelpers . fetch_change ( account_changeset , [ :user , :config , :address , :street ] )","ref":"ChangesetHelpers.html#fetch_change/2","title":"ChangesetHelpers.fetch_change/2","type":"function"},{"doc":"Same as fetch_change/2 but returns the value or raises if the given nested key was not found. street = ChangesetHelpers . fetch_change! ( account_changeset , [ :user , :config , :address , :street ] )","ref":"ChangesetHelpers.html#fetch_change!/2","title":"ChangesetHelpers.fetch_change!/2","type":"function"},{"doc":"Fetches the given nested field from changes or from the data. While fetch_change/2 only looks at the current changes to retrieve a value, this function looks at the changes and then falls back on the data, finally returning :error if no value is available. For relations, these functions will return the changeset original data with changes applied. To retrieve raw changesets, please use fetch_change/2 . { :changes , street } = ChangesetHelpers . fetch_field ( account_changeset , [ :user , :config , :address , :street ] )","ref":"ChangesetHelpers.html#fetch_field/2","title":"ChangesetHelpers.fetch_field/2","type":"function"},{"doc":"Same as fetch_field/2 but returns the value or raises if the given nested key was not found. street = ChangesetHelpers . fetch_field! ( account_changeset , [ :user , :config , :address , :street ] )","ref":"ChangesetHelpers.html#fetch_field!/2","title":"ChangesetHelpers.fetch_field!/2","type":"function"},{"doc":"","ref":"ChangesetHelpers.html#field_fails_validation?/3","title":"ChangesetHelpers.field_fails_validation?/3","type":"function"},{"doc":"","ref":"ChangesetHelpers.html#field_violates_constraint?/3","title":"ChangesetHelpers.field_violates_constraint?/3","type":"function"},{"doc":"Puts the given nested association in the changeset through a given list of field names. ChangesetHelpers . put_assoc ( account_changeset , [ :user , :config , :address ] , address_changeset ) Instead of giving a Changeset or a schema as the third argument, a function may also be given receiving the nested Changeset(s) to be updated as argument. ChangesetHelpers . put_assoc ( account_changeset , [ :user , :articles ] , &amp; ( Enum . concat ( &amp;1 , [ % Article { } |&gt; Ecto.Changeset . change ( ) ] ) ) ) In the code above, we add a new empty Article to the articles association (typically done when we want to add a new article to a form).","ref":"ChangesetHelpers.html#put_assoc/3","title":"ChangesetHelpers.put_assoc/3","type":"function"},{"doc":"Puts the given nested association in the changeset at the given index. See put_assoc(changeset, keys, value) .","ref":"ChangesetHelpers.html#put_assoc/4","title":"ChangesetHelpers.put_assoc/4","type":"function"},{"doc":"Works like Ecto.Changeset.validate_change/3 but may receive multiple fields. The validator function receives as argument a keyword list, where the keys are the field names and the values are the change for this field, or the data.any() If one of the fields is nil , the validator function is not invoked.","ref":"ChangesetHelpers.html#validate_changes/4","title":"ChangesetHelpers.validate_changes/4","type":"function"},{"doc":"Validates the result of the comparison of two fields (where at least one is a change) or a change and a value, where the value is an integer, a Date , a Time , a DateTime or a NaiveDateTime . Options :error_on_field - specifies on which field to add the error, defaults to the first field :message - a customized message on failure","ref":"ChangesetHelpers.html#validate_comparison/5","title":"ChangesetHelpers.validate_comparison/5","type":"function"},{"doc":"Validates a list of values using the given validator. changeset = % Appointment { } |&gt; Appointment . changeset ( %{ days_of_week : [ 1 , 3 , 8 ] } ) |&gt; validate_list ( :days_of_week , &amp; Ecto.Changeset . validate_inclusion / 3 , [ 1 .. 7 ] ) assert [ days_of_week : { &quot;is invalid&quot; , [ validation : :list , index : 2 , validator : :validate_inclusion ] } ] = changeset . errors assert [ days_of_week : { :list , [ validator : :validate_inclusion ] } ] = changeset . validations","ref":"ChangesetHelpers.html#validate_list/4","title":"ChangesetHelpers.validate_list/4","type":"function"},{"doc":"This library provides a set of helper functions to work with Ecto Changesets. validate_comparison(changeset, field1, operator, field2_or_value, opts) Validates the result of the comparison of two fields (where at least one is a change) or a change and a value, where the value is an integer, a Date , a Time , a DateTime or a NaiveDateTime . validate_comparison ( changeset , :start_time , :lt , :end_time ) assert [ start_time : { &quot;must be less than 10:00:00&quot; , [ validation : :comparison ] } ] = changeset . errors assert [ start_time : :comparison , end_time : :comparison ] = changeset . validations validate_comparison ( appointment_changeset , :end_time , :lt , ~T[21:00:00] ) assert [ end_time : { &quot;must be less than 21:00:00&quot; , [ validation : :comparison ] } ] = changeset . errors assert [ end_time : :comparison ] = changeset . validations validate_list(changeset, field, validation_fun, validation_fun_args) Validates a list of values using the given validator. changeset = % Appointment { } |&gt; Appointment . changeset ( %{ days_of_week : [ 1 , 3 , 8 ] } ) |&gt; validate_list ( :days_of_week , &amp; Ecto.Changeset . validate_inclusion / 3 , [ 1 .. 7 ] ) assert [ days_of_week : { &quot;is invalid&quot; , [ validation : :list , index : 2 , validator : :validate_inclusion ] } ] = changeset . errors assert [ days_of_week : { :list , [ validator : :validate_inclusion ] } ] = changeset . validations As the validator function is from the Ecto.Changeset module, you may just write :validate_inclusion . put_assoc(changeset, keys, value) Puts the given nested association in the changeset through a given list of field names. ChangesetHelpers . put_assoc ( account_changeset , [ :user , :config , :address ] , address_changeset ) Instead of giving a Changeset or a schema as the third argument, a function may also be given in order to modify the nested changeset in one go. ChangesetHelpers . put_assoc ( account_changeset , [ :user , :articles ] , &amp; ( Enum . concat ( &amp;1 , [ % Article { } |&gt; Ecto.Changeset . change ( ) ] ) ) ) In the code above, we change a new empty Article, and add the changeset into the articles association (typically done when we want to add a new row of form inputs to add an entity into a form handling a nested collection of entities). put_assoc(changeset, keys, index, value) Puts the given nested association in the changeset through a given list of field names, at the given index. change_assoc(struct_or_changeset, keys, changes \\\\ %{}) Returns the nested association in a changeset. This function will first look into the changes and then fails back on data wrapped in a changeset. Changes may be added to the given changeset through the third argument. A tuple is returned containing the modified root changeset and the changeset of the association. { account_changeset , address_changeset } = change_assoc ( account_changeset , [ :user , :user_config , :address ] , %{ street : &quot;Foo street&quot; } ) change_assoc(struct_or_changeset, keys, index, changes \\\\ %{}) Returns the nested association in a changeset at the given index. fetch_field(changeset, keys) Fetches the given nested field from changes or from the data. { :changes , street } = ChangesetHelpers . fetch_field ( account_changeset , [ :user , :config , :address , :street ] ) fetch_field!(changeset, keys) Same as fetch_field/2 but returns the value or raises if the given nested key was not found. street = ChangesetHelpers . fetch_field! ( account_changeset , [ :user , :config , :address , :street ] ) fetch_change(changeset, keys) Fetches the given nested field from changes or from the data. { :ok , street } = ChangesetHelpers . fetch_change ( account_changeset , [ :user , :config , :address , :street ] ) fetch_change!(changeset, keys) Same as fetch_change/2 but returns the value or raises if the given nested key was not found. street = ChangesetHelpers . fetch_change! ( account_changeset , [ :user , :config , :address , :street ] ) diff_field(changeset1, changeset2, keys) This function allows checking if a given field is different in two changesets. { street_changed , street1 , street2 } = diff_field ( account_changeset , new_account_changeset , [ :user , :user_config , :address , :street ] ) add_error(changeset, keys, message, extra \\\\ []) Adds an error to the nested changeset. ChangesetHelpers . add_error ( account_changeset , [ :user , :articles , :error_key ] , &quot;Some error&quot; ) field_fails_validation?(changeset, field, validations) Checks whether a field as the given validation error key. field_fails_validation? ( changeset , :email , :unsafe_unique ) field_violates_constraint?(changeset, field, constraints) Checks whether a field as the given constraint error key. field_violates_constraint? ( changeset , :email , :unique ) validate_changes(changeset, fields, meta, validator) Works like Ecto.Changeset.validate_change/3 but may receive multiple fields.","ref":"readme.html","title":"ChangesetHelpers","type":"extras"},{"doc":"Add changeset_helpers for Elixir as a dependency in your mix.exs file: def deps do [ { :changeset_helpers , &quot;~&gt; 0.17.0&quot; } ] end","ref":"readme.html#installation","title":"ChangesetHelpers - Installation","type":"extras"},{"doc":"HexDocs documentation can be found at https://hexdocs.pm/changeset_helpers .","ref":"readme.html#hexdocs","title":"ChangesetHelpers - HexDocs","type":"extras"}]